import 'package:flutter/material.dart';
import 'package:dgg_flutter_refresh/pull_refresh/screenutil.dart';
import 'package:dgg_flutter_refresh/pull_refresh/pull_to_refresh.dart';
import 'package:dgg_flutter_refresh/pull_refresh/src/loadStatusView.dart';
import 'package:dgg_flutter_refresh/pull_refresh/src/loadsStatus.dart';

//         refreshingIcon: buildRotationTransition(),
//         completeIcon: emptyWidget(),
//         idleIcon: logoIcon(),
//         releaseIcon: logoIcon(),
//         completeText: "",
//         refreshingText: "",//正在加载中...
//         idleText: "",//下拉刷新
//         releaseText: "",//下拉刷新
//         failedText: "",//加载失败
class PullRefresh extends StatefulWidget {
  final bool refreshEnable;
  final bool loadMoreEnable;
  final RefreshController refreshController;
  final VoidCallback onRefreshListener;
  final VoidCallback onLoadMoreListener;
  final Widget child;

  ///请求下拉刷新样式
  final Widget headerRefreshing;
  final Widget headerComplete;
  final Widget headeRidle;
  final Widget headerRelease;
  final String headerCompleteText;
  final String headerRefreshingText;
  final String headerIdleText;
  final String headerReleaseText;
  final String headerfailedText;

  ///请求上拉刷新样式
        // noDataText: "没有更多数据了",
        // loadingText: "正在加载更多",
        // canLoadingText: "上拉加载更多",
        // failedText: "加载失败",
        // idleText: "正在加载中...",
  final Widget footerLoading;
  final Widget footerCanLoading;
  final Widget footerIdle;
  final Widget footerNoMore;
  final Widget footerFailed;
  final String footerLoadingText;
  final String footerCanLoadingText;
  final String footerFailedText;
  final String footerIdleText;
  final String footerNoDataText;
  final int loadStatus;
  final Widget noNetworkWidget;
  final Widget noDataWidget;
  final Widget loadingWidget;
  final Color statusBgColor;

  PullRefresh(
      {this.refreshEnable: true,
      this.loadMoreEnable: true,
      @required this.refreshController,
      this.onRefreshListener,
      this.onLoadMoreListener,
      @required this.child,
      this.headerRefreshing,
      this.headerComplete,
      this.headeRidle,
      this.headerRelease,
      this.headerCompleteText,
      this.headerRefreshingText,
      this.headerIdleText,
      this.headerReleaseText,
      this.headerfailedText,
      this.footerLoading,
      this.footerIdle,
      this.footerNoMore,
      this.footerFailed,
      this.footerLoadingText,
      this.footerCanLoadingText,
      this.footerFailedText,
      this.footerIdleText,
      this.footerNoDataText,
      this.footerCanLoading,
      this.loadStatus,
      @required this.noNetworkWidget,
      @required this.noDataWidget,
      @required this.loadingWidget,
      this.statusBgColor
      });

  @override
  _PullRefreshState createState() => _PullRefreshState();
}

class _PullRefreshState extends State<PullRefresh>
    with SingleTickerProviderStateMixin {

  @override
  void initState() {
    super.initState();
  }
  @override
  void dispose() {
    super.dispose();
  }
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: Stack(
        children: <Widget>[
          StatusViews(
              widget.loadStatus,
              widget.noNetworkWidget,
              widget.noDataWidget,
              widget.loadingWidget,
              widget.statusBgColor,
              onTap: () {
                widget.onRefreshListener();
              },
            ),
          SmartRefresher(
            enablePullDown: widget.refreshEnable,
            enablePullUp: widget.loadStatus != LoadsStatus.success ? false : widget.loadMoreEnable,
            footer: ClassicFooter(
              loadingIcon: widget.footerLoading,
              idleIcon: widget.footerIdle,
              noMoreIcon: widget.footerNoMore,
              failedIcon: widget.footerFailed,
              canLoadingIcon: widget.footerCanLoading,
              noDataText: widget.footerNoDataText ?? "没有更多数据了",
              loadingText: widget.footerLoadingText ?? "正在加载更多",
              canLoadingText: widget.footerCanLoadingText ?? "上拉加载更多",
              failedText: widget.footerFailedText ?? "加载失败",
              idleText: widget.footerIdleText ?? "正在加载中...",
            ),
            header: ClassicHeader(
              refreshingIcon: widget.headerRefreshing,
              completeIcon: widget.headerComplete,
              idleIcon: widget.headeRidle,
              releaseIcon: widget.headerRelease,
              completeText: widget.headerCompleteText ?? "刷新完成",
              refreshingText: widget.headerRefreshingText ?? "正在加载中...",//正在加载中...
              idleText: widget.headerIdleText ?? "下拉刷新",//下拉刷新
              releaseText: widget.headerReleaseText ?? "下拉刷新",//下拉刷新
              failedText: widget.headerfailedText ?? "加载失败",//加载失败
            ),
            controller: widget.refreshController,
            onRefresh: widget.onRefreshListener,
            onLoading: widget.onLoadMoreListener,
            child: widget.child,
          ),
        ],
      ),
    );
  }
}

