

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'loadsStatus.dart';

class StatusViews extends StatelessWidget {
  const StatusViews(this.status,this.noNetworkWidget,this.noDataWidget, this.loadingWidget,this.statusViewsBgColor,{Key key, this.onTap}) : super(key: key);
  final int status;
  final GestureTapCallback onTap;
  final Widget noNetworkWidget;
  final Widget noDataWidget;
  final Widget loadingWidget;
  final Color statusViewsBgColor;  

  @override
  Widget build(BuildContext context) {
    switch (status) {
      case LoadsStatus.fail:
        return new Container(
          width: double.infinity,
          child: new Material(
            color: statusViewsBgColor ?? Colors.white,
            child: new InkWell(
              onTap: () {
                onTap();
              },
              child: noNetworkWidget ?? new Column(
                mainAxisAlignment: MainAxisAlignment.center,
                children: <Widget>[
                  new Image.asset(
                    "images/noNetwork.png",
                    package: "dgg_flutter_refresh",
                    width: 100,
                    height: 100,
                  ),
                  SizedBox(width: 10),
                  new Text(
                    "网络出问题了～ 请您查看网络设置",
                    style: TextStyle(
                      fontSize: 14,
                      color: Color.fromRGBO(0, 0, 0, 1)
                    )
                  ),
                  SizedBox(width: 5),
                  new Text(
                    "点击屏幕，重新加载",
                    style: TextStyle(
                      fontSize: 14,
                      color: Color.fromRGBO(0, 0, 0, 1)
                    )
                  ),
                ],
              ),
            ),
          ),
        );
        break;
      case LoadsStatus.loading:
        return new Container(
          color: statusViewsBgColor ?? Colors.white,
          child: loadingWidget ?? new ProgressView(),
        );
        break;
      case LoadsStatus.empty:
        return new Container(
          color: statusViewsBgColor ?? Colors.white,
          width: double.infinity,
          child: new Center(
            child: noDataWidget ?? new Column(
              mainAxisAlignment: MainAxisAlignment.center,
              children: <Widget>[
                new Image.asset(
                  "images/noData.png",
                  package: "dgg_flutter_refresh",
                  width: 60,
                  height: 60,
                ),
                SizedBox(width: 10,),
                new Text(
                  "空空如也～",
                  style: TextStyle(
                      fontSize: 14,
                      color: Color.fromRGBO(0, 0, 0, 1)
                    )
                ),
              ],
            ),
          ),
        );
        break;
      default:
        return Container();
        break;
    }
  }
}

class ProgressView extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return new Center(
      child: new SizedBox(
        width: 24.0,
        height: 24.0,
        child: new CircularProgressIndicator(
          strokeWidth: 2.0,
        ),
      ),
    );
  }
}